/* install GCC 4 runtime libraries needed for all Qt 4 installations. 
 * This program is intended to be called from Suntan Special
 *
 * Description
 *   This command installs GCC 4 runtime libraries needed for all Qt 4
 *   installations. OS/2 is temporarily unsupported unless it has the
 *   eCS directory tree. The installation is unattended.
 *
 * Copyright (C) 2015 Blonde Guy
 * All Rights Reserved
 */

productName = "GCC 4 Core"
productDate = '2015-12-07 19:46:26'
productCategory = 'Library'
productID = ''
fileURL = 'ftp://ftp.netlabs.org/pub/gcc/gcc4core-1_3_1.wpi;' ||,
          'ftp://ftp.netlabs.org/pub/gcc/libc-0_6_6-csd6.wpi'

parse arg appsDir
installDir = FindBootDrive() || ':\ecs\dll'
originalDir = Directory()
call LogCdi "Installing" productName "to" installDir

call LogCdi "Locating existing WarpIN installation"
wiloc = strip(SysIni("USER", "WarpIN", "Path"), 't', d2c(0))
if wiloc = 'ERROR:' then do
   call LogCdi "WarpIN was not found." productName "will not be installed."
   return 1
end

call LogCdi "creating temporary directory"
TempDir = value('TEMP',,'OS2ENVIRONMENT') || '\gcclib'
rc = SuntanMkDir(TempDir)
if rc <> 0 & rc <> 5 then do
   call LogCdi "Error" rc "creating temporary directory" tempDir
   return 1
end

call DoWarpIN 'libc-0_6_6-csd6.wpi', 'libc-0_6_6-csd6.xcd'
call DoWarpIN 'gcc4core-1_3_1.wpi', 'gcc4core-1_3_1.xcd'

address cmd '@deltree /y' tempDir '> nul'
if rc <> 0 then do
   call LogCdi "Error" rc "deleting temporary files"
end

call LogCdi "Operation Complete."
return 0



/* does WarpIN install */
DoWarpIN:

WarpINDist = strip(arg(1))
WarpINCid = strip(arg(2))

if WarpINDist = '' then do
   call LogCdi "missing WarpIN distribution"
   return 1
end

if WarpINCid = '' then do
   call LogCdi "missing WarpIN response file"
   return 1
end

call Directory originalDir
address cmd '@copy' WarpINCid tempDir '> nul'
if rc <> 0 then do
   call LogCdi "Error" rc "copying install script" WarpINCid
   return 1
end
else do
   queue 'ReadConfigFile'
   /* customize editing of XCD files goes here */
   queue 'ReplaceLine filename= filename="' || originalDir || '\' || WarpINDist || '">'
   queue 'ReplaceLine path="H:\ecs\dll" path="' || installDir || '"'
   queue 'ReplaceLine path="H:\ECS\DLL" path="' || installDir || '"'
   queue 'ReplaceLine path="H:\ecs\DOC\GCC4" path="' || FindBootDrive() || ':\ecs\DOC\GCC4"'
   queue 'WriteConfigFile'
   queue 'exit'
   call EditFile 'nul' tempDir || '\' || WarpINCid

   errfile = tempDir || '\error.log'
   call Directory wiloc
   address cmd '@' wiloc || '\wic -i -R' tempDir || '\' || WarpINCid '>' errfile '2>&1'
   if rc <> 0 then do
      call LogCdi "installer returned" rc
      do while lines(errfile)
         call LogCdi linein(errfile)
      end
      call stream errfile, 'c', 'close'
   end
   else do
      call LogCdi "WarpIN reports a successful install for" WarpINDist
   end

   if productID <> '' then call ProgramFolder productID
end

return 0
