/* DoYum.cmd
 * run a yum command from Suntan Special
 *
 * Arguments
 *   arg(1) - command String
 *
 * Copyright (C) 2017 Blonde Guy
 * All Rights Reserved
 */

parse arg commandStr

if commandStr = '' then do
   call LogCdi "usage: doYum commandString"
   return 1
end

yrc = performYum(commandStr)

call LogCdi "doYum(" || commandStr || ") returned" yrc

return yrc


performYum:
parse arg commandStr

errfile = value('TEMP',,'OS2ENVIRONMENT') || '\yum.err'
status = 'OK'
cr = d2c(13)
do while status = 'OK'
   call LogCdi "executing yum" commandStr
   address cmd '@yum -y' commandStr '>' errfile '2>&1'
   yrc = rc
   do while lines(errfile)
      call LogCdi linein(errfile)
   end
   call stream errfile, 'c', 'close'
   if rc <> 0 then do
      status = radiolist("Error", "The yum command did not complete successfully.",
                         "Check the log for additional information."  || cr ||,
                         "Select OK to repeat the command,",
                         "Cancel to abandon product installation, or",
                         "Continue to ignore the error and continue product installation.",,
                         "Enter choice:", "OK", "Cancel", "!Continue")
   end
   else do
      status = 'Done'
   end
end

call SysFileDelete errfile

if rc <> 0 then do
   if status = 'Continue' then do
      rc = 0
   end
end

call LogCdi "yum completed, status:" status
return rc

